diff --git a/web/pgadmin/feature_tests/query_tool_auto_complete_tests.py b/web/pgadmin/feature_tests/query_tool_auto_complete_tests.py
new file mode 100644
index 0000000..2e0dd4a
--- /dev/null
+++ b/web/pgadmin/feature_tests/query_tool_auto_complete_tests.py
@@ -0,0 +1,156 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import sys
+import random
+
+from selenium.webdriver import ActionChains
+from selenium.webdriver.common.keys import Keys
+from selenium.webdriver.support.ui import WebDriverWait
+from selenium.webdriver.support import expected_conditions as EC
+from regression.python_test_utils import test_utils
+from regression.feature_utils.base_feature_test import BaseFeatureTest
+
+
+class QueryToolAutoCompleteFeatureTest(BaseFeatureTest):
+    """
+        This feature test will test the query tool auto complete feature.
+    """
+
+    first_table_name = ""
+    second_table_name = ""
+
+    scenarios = [
+        ("Query tool auto complete feature test", dict())
+    ]
+
+    def before(self):
+        self.page.wait_for_spinner_to_disappear()
+
+        self.page.add_server(self.server)
+        self.first_table_name = "auto_comp_" + \
+                                str(random.randint(1000, 3000))
+        test_utils.create_table(self.server, self.test_db,
+                                self.first_table_name)
+
+        self.second_table_name = "auto_comp_" + \
+                                 str(random.randint(1000, 3000))
+        test_utils.create_table(self.server, self.test_db,
+                                self.second_table_name)
+
+        self._locate_database_tree_node()
+        self.page.open_query_tool()
+        self.page.wait_for_spinner_to_disappear()
+
+    def runTest(self):
+        # Test case for keywords
+        print("\nAuto complete ALTER keyword... ", file=sys.stderr, end="")
+        self._auto_complete("A", "ALTER")
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete BEGIN keyword... ", file=sys.stderr, end="")
+        self._auto_complete("BE", "BEGIN")
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete CASCADED keyword... ", file=sys.stderr, end="")
+        self._auto_complete("CAS", "CASCADED")
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete SELECT keyword... ", file=sys.stderr, end="")
+        self._auto_complete("SE", "SELECT")
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete pg_backend_pid() function ... ",
+              file=sys.stderr, end="")
+        self._auto_complete("SELECT pg_", "pg_backend_pid()")
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete current_query() function ... ",
+              file=sys.stderr, end="")
+        self._auto_complete("SELECT current_", "current_query()")
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete function with argument ... ",
+              file=sys.stderr, end="")
+        self._auto_complete("SELECT pg_st", "pg_stat_file(filename)")
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete first table in public schema ... ",
+              file=sys.stderr, end="")
+        self._auto_complete("SELECT * FROM public.", self.first_table_name)
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete second table in public schema ... ",
+              file=sys.stderr, end="")
+        self._auto_complete("SELECT * FROM public.", self.second_table_name)
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete JOIN second table with after schema name ... ",
+              file=sys.stderr, end="")
+        query = "SELECT * FROM public." + self.first_table_name + \
+                " JOIN public."
+        self._auto_complete(query, self.second_table_name)
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete JOIN ON some columns ... ",
+              file=sys.stderr, end="")
+        query = "SELECT * FROM public." + self.first_table_name + \
+                " JOIN public." + self.second_table_name + " ON " + \
+                self.second_table_name + "."
+        expected_string = "some_column = " + self.first_table_name + \
+                          ".some_column"
+        self._auto_complete(query, expected_string)
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+        print("Auto complete JOIN ON some columns using tabel alias ... ",
+              file=sys.stderr, end="")
+        query = "SELECT * FROM public." + self.first_table_name + \
+                " t1 JOIN public." + self.second_table_name + " t2 ON t2."
+        self._auto_complete(query, "some_column = t1.some_column")
+        print("OK.", file=sys.stderr)
+        self._clear_query_tool()
+
+    def after(self):
+        self.page.remove_server(self.server)
+
+    def _locate_database_tree_node(self):
+        self.page.toggle_open_tree_item(self.server['name'])
+        self.page.toggle_open_tree_item('Databases')
+        self.page.toggle_open_tree_item(self.test_db)
+
+    def _clear_query_tool(self):
+        self.page.click_element(
+            self.page.find_by_xpath("//*[@id='btn-clear-dropdown']")
+        )
+        ActionChains(self.driver) \
+            .move_to_element(self.page.find_by_xpath("//*[@id='btn-clear']")) \
+            .perform()
+        self.page.click_element(
+            self.page.find_by_xpath("//*[@id='btn-clear']")
+        )
+        self.page.click_modal('Yes')
+
+    def _auto_complete(self, word, expected_string):
+        self.page.fill_codemirror_area_with(word)
+        ActionChains(self.page.driver).key_down(
+            Keys.CONTROL).send_keys(Keys.SPACE).key_up(Keys.CONTROL).perform()
+        self.page.find_by_xpath(
+            "//ul[contains(@class, 'CodeMirror-hints') and "
+            "contains(., '" + expected_string + "')]")
diff --git a/web/pgadmin/utils/sqlautocomplete/autocomplete.py b/web/pgadmin/utils/sqlautocomplete/autocomplete.py
index 8a25c13..3efac77 100644
--- a/web/pgadmin/utils/sqlautocomplete/autocomplete.py
+++ b/web/pgadmin/utils/sqlautocomplete/autocomplete.py
@@ -9,60 +9,71 @@
 
 """A blueprint module implementing the sql auto complete feature."""
 
-import itertools
-import operator
 import re
-import sys
-from collections import namedtuple
-
-import sqlparse
+import operator
+from itertools import count, repeat, chain
+from .completion import Completion
+from collections import namedtuple, defaultdict, OrderedDict
+from .sqlcompletion import (
+    FromClauseItem, suggest_type, Database, Schema, Table,
+    Function, Column, View, Keyword, Datatype, Alias, JoinCondition, Join)
+from .parseutils.meta import FunctionMetadata, ColumnMetadata, ForeignKey
+from .parseutils.utils import last_word
+from .parseutils.tables import TableReference
+from .prioritization import PrevalenceCounter
 from flask import render_template
 from pgadmin.utils.driver import get_driver
-from sqlparse.sql import Comparison, Identifier, Where
-
 from config import PG_DEFAULT_DRIVER
-from .completion import Completion
-from .function_metadata import FunctionMetadata
-from .parseutils import (
-    last_word, extract_tables, find_prev_keyword, parse_partial_identifier)
-from .prioritization import PrevalenceCounter
 from pgadmin.utils.preferences import Preferences
 
-PY2 = sys.version_info[0] == 2
-PY3 = sys.version_info[0] == 3
-
-if PY3:
-    string_types = str
-else:
-    string_types = basestring
-
-Database = namedtuple('Database', [])
-Schema = namedtuple('Schema', [])
-Table = namedtuple('Table', ['schema'])
+Match = namedtuple('Match', ['completion', 'priority'])
 
-Function = namedtuple('Function', ['schema', 'filter'])
-# For convenience, don't require the `filter` argument in Function constructor
-Function.__new__.__defaults__ = (None, None)
+_SchemaObject = namedtuple('SchemaObject', 'name schema meta')
 
-Column = namedtuple('Column', ['tables', 'drop_unique'])
-Column.__new__.__defaults__ = (None, None)
 
-View = namedtuple('View', ['schema'])
-Keyword = namedtuple('Keyword', [])
-Datatype = namedtuple('Datatype', ['schema'])
-Alias = namedtuple('Alias', ['aliases'])
-Match = namedtuple('Match', ['completion', 'priority'])
+def SchemaObject(name, schema=None, meta=None):
+    return _SchemaObject(name, schema, meta)
 
-try:
-    from collections import Counter
-except ImportError:
-    # python 2.6
-    from .counter import Counter
 
 # Regex for finding "words" in documents.
 _FIND_WORD_RE = re.compile(r'([a-zA-Z0-9_]+|[^a-zA-Z0-9_\s]+)')
 _FIND_BIG_WORD_RE = re.compile(r'([^\s]+)')
 
+_Candidate = namedtuple(
+    'Candidate', 'completion prio meta synonyms prio2 display'
+)
+
+
+def Candidate(
+    completion, prio=None, meta=None, synonyms=None, prio2=None,
+    display=None
+):
+    return _Candidate(
+        completion, prio, meta, synonyms or [completion], prio2,
+        display or completion
+    )
+
+
+# Used to strip trailing '::some_type' from default-value expressions
+arg_default_type_strip_regex = re.compile(r'::[\w\.]+(\[\])?$')
+
+
+def normalize_ref(ref):
+    return ref if ref[0] == '"' else '"' + ref.lower() + '"'
+
+
+def generate_alias(tbl):
+    """ Generate a table alias, consisting of all upper-case letters in
+    the table name, or, if there are no upper-case letters, the first letter +
+    all letters preceded by _
+    param tbl - unescaped name of the table to alias
+    """
+    return ''.join(
+        [letter for letter in tbl if letter.isupper()] or
+        [letter for letter, prev in zip(tbl, '_' + tbl)
+         if prev == '_' and letter != '_']
+    )
+
 
 class SQLAutoComplete(object):
     """
@@ -73,7 +84,6 @@ class SQLAutoComplete(object):
         the connection and get the tables, schemas, functions etc. based on
         the query.
     """
-
     def __init__(self, **kwargs):
         """
         This method is used to initialize the class.
@@ -83,9 +93,15 @@ class SQLAutoComplete(object):
         """
 
         self.sid = kwargs['sid'] if 'sid' in kwargs else None
-        self.did = kwargs['did'] if 'did' in kwargs else None
         self.conn = kwargs['conn'] if 'conn' in kwargs else None
         self.keywords = []
+        self.databases = []
+        self.functions = []
+        self.datatypes = []
+        self.dbmetadata = {'tables': {}, 'views': {}, 'functions': {},
+                           'datatypes': {}}
+        self.text_before_cursor = None
+        self.name_pattern = re.compile("^[_a-z][_a-z0-9\$]*$")
 
         manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(self.sid)
 
@@ -93,6 +109,7 @@ class SQLAutoComplete(object):
         self.sql_path = 'sqlautocomplete/sql/#{0}#'.format(manager.version)
 
         self.search_path = []
+        schema_names = []
         # Fetch the search path
         if self.conn.connected():
             query = render_template(
@@ -100,6 +117,7 @@ class SQLAutoComplete(object):
             status, res = self.conn.execute_dict(query)
             if status:
                 for record in res['rows']:
+                    schema_names.append(record['schema'])
                     self.search_path.append(record['schema'])
 
             pref = Preferences.module('sqleditor')
@@ -118,22 +136,44 @@ class SQLAutoComplete(object):
                 for record in res['rows']:
                     self.keywords.append(record['word'])
 
-        self.text_before_cursor = None
         self.prioritizer = PrevalenceCounter(self.keywords)
 
         self.reserved_words = set()
         for x in self.keywords:
             self.reserved_words.update(x.split())
-        self.name_pattern = re.compile("^[_a-z][_a-z0-9\$]*$")
+
+        self.all_completions = set(self.keywords)
+        self.extend_schemata(schema_names)
+
+        # Below are the configurable options in pgcli which we don't have
+        # in pgAdmin4 at the moment. Setting the default value from the pgcli's
+        # config file.
+        self.signature_arg_style = '{arg_name} {arg_type}'
+        self.call_arg_style = '{arg_name: <{max_arg_len}} := {arg_default}'
+        self.call_arg_display_style = '{arg_name}'
+        self.call_arg_oneliner_max = 2
+        self.search_path_filter = True
+        self.generate_aliases = False
+        self.insert_col_skip_patterns = [
+            re.compile(r'^now\(\)$'),
+            re.compile(r'^nextval\(')]
+        self.qualify_columns = 'if_more_than_one_table'
+        self.asterisk_column_order = 'table_order'
 
     def escape_name(self, name):
-        if name and ((not self.name_pattern.match(name)) or
-                     (name.upper() in self.reserved_words)):
+        if name and (
+            (not self.name_pattern.match(name)) or
+            (name.upper() in self.reserved_words)
+        ):
             name = '"%s"' % name
 
         return name
 
+    def escape_schema(self, name):
+        return "'{}'".format(self.unescape_name(name))
+
     def unescape_name(self, name):
+        """ Unquote a string."""
         if name and name[0] == '"' and name[-1] == '"':
             name = name[1:-1]
 
@@ -142,15 +182,176 @@ class SQLAutoComplete(object):
     def escaped_names(self, names):
         return [self.escape_name(name) for name in names]
 
-    def find_matches(self, text, collection, mode='fuzzy',
-                     meta=None, meta_collection=None):
+    def extend_database_names(self, databases):
+        self.databases.extend(databases)
+
+    def extend_keywords(self, additional_keywords):
+        self.keywords.extend(additional_keywords)
+        self.all_completions.update(additional_keywords)
+
+    def extend_schemata(self, schemata):
+
+        # schemata is a list of schema names
+        schemata = self.escaped_names(schemata)
+        metadata = self.dbmetadata['tables']
+        for schema in schemata:
+            metadata[schema] = {}
+
+        # dbmetadata.values() are the 'tables' and 'functions' dicts
+        for metadata in self.dbmetadata.values():
+            for schema in schemata:
+                metadata[schema] = {}
+
+        self.all_completions.update(schemata)
+
+    def extend_casing(self, words):
+        """ extend casing data
+
+        :return:
         """
-        Find completion matches for the given text.
+        # casing should be a dict {lowercasename:PreferredCasingName}
+        self.casing = dict((word.lower(), word) for word in words)
+
+    def extend_relations(self, data, kind):
+        """extend metadata for tables or views.
+
+        :param data: list of (schema_name, rel_name) tuples
+        :param kind: either 'tables' or 'views'
+
+        :return:
+
+        """
+
+        data = [self.escaped_names(d) for d in data]
+
+        # dbmetadata['tables']['schema_name']['table_name'] should be an
+        # OrderedDict {column_name:ColumnMetaData}.
+        metadata = self.dbmetadata[kind]
+        for schema, relname in data:
+            try:
+                metadata[schema][relname] = OrderedDict()
+            except KeyError:
+                print('%r %r listed in unrecognized schema %r',
+                      kind, relname, schema)
+
+            self.all_completions.add(relname)
+
+    def extend_columns(self, column_data, kind):
+        """extend column metadata.
+
+        :param column_data: list of (schema_name, rel_name, column_name,
+        column_type, has_default, default) tuples
+        :param kind: either 'tables' or 'views'
+
+        :return:
+
+        """
+        metadata = self.dbmetadata[kind]
+        for schema, relname, colname, datatype, \
+                has_default, default in column_data:
+            (schema, relname, colname) = self.escaped_names(
+                [schema, relname, colname])
+            column = ColumnMetadata(
+                name=colname,
+                datatype=datatype,
+                has_default=has_default,
+                default=default
+            )
+            metadata[schema][relname][colname] = column
+            self.all_completions.add(colname)
+
+    def extend_functions(self, func_data):
+
+        # func_data is a list of function metadata namedtuples
+
+        # dbmetadata['schema_name']['functions']['function_name'] should return
+        # the function metadata namedtuple for the corresponding function
+        metadata = self.dbmetadata['functions']
+
+        for f in func_data:
+            schema, func = self.escaped_names([f.schema_name, f.func_name])
+
+            if func in metadata[schema]:
+                metadata[schema][func].append(f)
+            else:
+                metadata[schema][func] = [f]
+
+            self.all_completions.add(func)
+
+        self._refresh_arg_list_cache()
+
+    def _refresh_arg_list_cache(self):
+        # We keep a cache of
+        # {function_usage:{function_metadata: function_arg_list_string}}
+        # This is used when suggesting functions, to avoid the latency that
+        # would result if we'd recalculate the arg lists each time we suggest
+        # functions (in large DBs)
+        self._arg_list_cache = {
+            usage: {
+                meta: self._arg_list(meta, usage)
+                for sch, funcs in self.dbmetadata['functions'].items()
+                for func, metas in funcs.items()
+                for meta in metas
+            }
+            for usage in ('call', 'call_display', 'signature')
+        }
+
+    def extend_foreignkeys(self, fk_data):
+
+        # fk_data is a list of ForeignKey namedtuples, with fields
+        # parentschema, childschema, parenttable, childtable,
+        # parentcolumns, childcolumns
+
+        # These are added as a list of ForeignKey namedtuples to the
+        # ColumnMetadata namedtuple for both the child and parent
+        meta = self.dbmetadata['tables']
+
+        for fk in fk_data:
+            e = self.escaped_names
+            parentschema, childschema = e([fk.parentschema, fk.childschema])
+            parenttable, childtable = e([fk.parenttable, fk.childtable])
+            childcol, parcol = e([fk.childcolumn, fk.parentcolumn])
+            childcolmeta = meta[childschema][childtable][childcol]
+            parcolmeta = meta[parentschema][parenttable][parcol]
+            fk = ForeignKey(
+                parentschema, parenttable, parcol,
+                childschema, childtable, childcol
+            )
+            childcolmeta.foreignkeys.append((fk))
+            parcolmeta.foreignkeys.append((fk))
+
+    def extend_datatypes(self, type_data):
+
+        # dbmetadata['datatypes'][schema_name][type_name] should store type
+        # metadata, such as composite type field names. Currently, we're not
+        # storing any metadata beyond typename, so just store None
+        meta = self.dbmetadata['datatypes']
+
+        for t in type_data:
+            schema, type_name = self.escaped_names(t)
+            meta[schema][type_name] = None
+            self.all_completions.add(type_name)
+
+    def set_search_path(self, search_path):
+        self.search_path = self.escaped_names(search_path)
+
+    def reset_completions(self):
+        self.databases = []
+        self.special_commands = []
+        self.search_path = []
+        self.dbmetadata = {'tables': {}, 'views': {}, 'functions': {},
+                           'datatypes': {}}
+        self.all_completions = set(self.keywords + self.functions)
+
+    def find_matches(self, text, collection, mode='fuzzy', meta=None):
+        """Find completion matches for the given text.
 
         Given the user's input text and a collection of available
         completions, find completions matching the last word of the
         text.
 
+        `collection` can be either a list of strings or a list of Candidate
+        namedtuples.
         `mode` can be either 'fuzzy', or 'strict'
             'fuzzy': fuzzy matching, ties broken by name prevalance
             `keyword`: start only matching, ties broken by keyword prevalance
@@ -165,7 +366,14 @@ class SQLAutoComplete(object):
             meta:
             meta_collection:
         """
-
+        if not collection:
+            return []
+        prio_order = [
+            'keyword', 'function', 'view', 'table', 'datatype', 'database',
+            'schema', 'column', 'table alias', 'join', 'name join', 'fk join',
+            'table format'
+        ]
+        type_priority = prio_order.index(meta) if meta in prio_order else -1
         text = last_word(text, include='most_punctuations').lower()
         text_len = len(text)
 
@@ -193,6 +401,12 @@ class SQLAutoComplete(object):
             pat = re.compile('(%s)' % regex)
 
             def _match(item):
+                if item.lower()[:len(text) + 1] in (text, text + ' '):
+                    # Exact match of first word in suggestion
+                    # This is to get exact alias matches to the top
+                    # E.g. for input `e`, 'Entries E' should be on top
+                    # (before e.g. `EndUsers EU`)
+                    return float('Infinity'), -1
                 r = pat.search(self.unescape_name(item.lower()))
                 if r:
                     return -len(r.group()), -r.start()
@@ -206,39 +420,56 @@ class SQLAutoComplete(object):
                     # fuzzy matches
                     return -float('Infinity'), -match_point
 
-        if meta_collection:
-            # Each possible completion in the collection has a corresponding
-            # meta-display string
-            collection = zip(collection, meta_collection)
-        else:
-            # All completions have an identical meta
-            collection = zip(collection, itertools.repeat(meta))
-
         matches = []
+        for cand in collection:
+            if isinstance(cand, _Candidate):
+                item, prio, display_meta, synonyms, prio2, display = cand
+                if display_meta is None:
+                    display_meta = meta
+                syn_matches = (_match(x) for x in synonyms)
+                # Nones need to be removed to avoid max() crashing in Python 3
+                syn_matches = [m for m in syn_matches if m]
+                sort_key = max(syn_matches) if syn_matches else None
+            else:
+                item, display_meta, prio, prio2, display = \
+                    cand, meta, 0, 0, cand
+                sort_key = _match(cand)
 
-        for item, meta in collection:
-            sort_key = _match(item)
             if sort_key:
-                if meta and len(meta) > 50:
+                if display_meta and len(display_meta) > 50:
                     # Truncate meta-text to 50 characters, if necessary
-                    meta = meta[:47] + u'...'
+                    display_meta = display_meta[:47] + u'...'
 
                 # Lexical order of items in the collection, used for
                 # tiebreaking items with the same match group length and start
                 # position. Since we use *higher* priority to mean "more
                 # important," we use -ord(c) to prioritize "aa" > "ab" and end
                 # with 1 to prioritize shorter strings (ie "user" > "users").
+                # We first do a case-insensitive sort and then a
+                # case-sensitive one as a tie breaker.
                 # We also use the unescape_name to make sure quoted names have
                 # the same priority as unquoted names.
-                lexical_priority = tuple(
-                    -ord(c) for c in self.unescape_name(item)) + (1,)
-
-                priority = sort_key, priority_func(item), lexical_priority
-
-                matches.append(Match(
-                    completion=Completion(item, -text_len, display_meta=meta),
-                    priority=priority))
+                lexical_priority = (
+                    tuple(0 if c in(' _') else -ord(c)
+                          for c in self.unescape_name(item.lower())) + (1,) +
+                    tuple(c for c in item)
+                )
 
+                priority = (
+                    sort_key, type_priority, prio, priority_func(item),
+                    prio2, lexical_priority
+                )
+                matches.append(
+                    Match(
+                        completion=Completion(
+                            text=item,
+                            start_position=-text_len,
+                            display_meta=display_meta,
+                            display=display
+                        ),
+                        priority=priority
+                    )
+                )
         return matches
 
     def get_completions(self, text, text_before_cursor):
@@ -246,7 +477,7 @@ class SQLAutoComplete(object):
 
         word_before_cursor = self.get_word_before_cursor(word=True)
         matches = []
-        suggestions = self.suggest_type(text, text_before_cursor)
+        suggestions = suggest_type(text, text_before_cursor)
 
         for suggestion in suggestions:
             suggestion_type = type(suggestion)
